{% load static %}
<head>
    <link rel="stylesheet" href="{% static 'style.css' %}">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.2.0/css/bootstrap.min.css" rel="stylesheet" id="bootstrap-css">
    <script src="//code.jquery.com/jquery-1.11.1.min.js"></script>
    <script src="//netdna.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
    <script src="{% static 'jquery-3.5.0.js' %}"></script>

    <script>
        let likedBooks;
        const get_top_5_books_url = "{% url 'get_top_5_books' %}"
        const add_liked_book_url = "{% url 'add_liked_book' %}"

        if (localStorage.getItem('likedBooks') == null) {
            likedBooks = [];
            localStorage.setItem('likedBooks', JSON.stringify(likedBooks));
        } else {
            likedBooks = JSON.parse(localStorage.getItem('likedBooks'));
        }
        
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie !== '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = cookies[i].trim();
                    if (cookie.substring(0, name.length + 1) === (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }
        var csrftoken = getCookie('csrftoken');

        function handleClickLikeButton(title, thumbnail) {
            let book = likedBooks.find(book => book.title == title);
            if (book) {
                console.log(book)
                let id = book.id;
                $.ajax({
                    headers: {'X-CSRFToken' : csrftoken},
                    method: 'POST',
                    url: `${window.location.href}api/add_like/${id}`,
                    success: resp => {
                        console.log(resp);
                        book.likes += 1;
                        localStorage.setItem("likedBooks", JSON.stringify(likedBooks))
                    },
                    error: err => console.log(err)
                })
            } else {
                $.ajax({
                    headers: {'X-CSRFToken' : csrftoken},
                    method: 'POST',
                    url: add_liked_book_url,
                    data: {
                        "title" : title,
                        "img_link" : thumbnail,
                        csrfmiddlewaretoken: window.CSRF_TOKEN
                    },
                    success: resp => {
                        console.log(resp);
                        likedBooks.push(resp);
                        localStorage.setItem("likedBooks", JSON.stringify(likedBooks));
                    },
                    error: err => console.log(err)
                })
            }
        }

        $(document).ready(function() {
            $('.search').keyup(function() {
                if ($('.search').val() != "") {
                    $('.tbody').empty();
                    $.getJSON(`https://www.googleapis.com/books/v1/volumes?q=${$('.search').val()}`, function(res) {
                        var items = res.items;
                        console.log(items);
                        $.map(items, function(item) {
                            let thumbnail = item.volumeInfo.imageLinks.thumbnail;
                            let title = item.volumeInfo.title;
                            let description = item.volumeInfo.description ? item.volumeInfo.description : "No description provided";
                            let authors = item.volumeInfo.authors ? item.volumeInfo.authors : "No author provided";
                            let table_html = `<div class="row">
                                                <div class="title_col">
                                                    <img src="${thumbnail}">
                                                    <p class="book_title">${title}</p>
                                                </div>
                                                <div class="desc_col">${description}</div>
                                                <div class="auth_col">${authors}</div>
                                                <div class="like_col"><button class="confirm_button" onClick="handleClickLikeButton('${title}', '${thumbnail}')" id="like">Like</button></div>
                                            </div>`
                            $('.tbody').append(table_html);
                        })
                    })
                }
            })

            $('#top5').click(function() {
                $('.modal-body').empty()
                $.getJSON(get_top_5_books_url, function(res) {
                    $.map(res, function(book) {
                        $('.modal-body').append(
                            `<div class="row_modal">
                                <img src="${book.img_link}" style="margin:auto;">
                                <p class="book_title" style="text-align: center; margin: 0.5rem, 0;">${book.title}</p>
                            </div>`
                        )
                    })
                })
            })
        })
    </script>
</head>

<body style="margin: auto;">
    <div class="title">BOOKLIST</div>

    <div class="container">
        <input class="search" placeholder="search here" type="text"></input>

        <button type="button" id= "top5" class="top5_button" data-toggle="modal" data-target="#exampleModal">Top 5 Books By Most Likes Received</button>
      
        <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">TOP 5 BOOKS BY LIKES</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                </div>
                <div class="modal-body">
                </div>
            </div>
            </div>
        </div>

        <table class="result">
            <div class="thead">
                <div class="row">
                    <div class = "title_col">Title</div>
                    <div class = "desc_col">Description</div>
                    <div class = "auth_col">Author</div>
                    <div class = "like_col"></div>
                </div>
            </div>
            <div class="tbody"></div>
        </table>
    </body>
    </div>
